#Universidad Nacional Autonoma de Mexico
#PAPIME PE 400216
#DGAPA
#Programacion y diseno: Hadassa Amelia Juarez Hernandez. 2016 Attributions in /attributions
#Uncommented version

import random
import os
import time
import pygame
from pygame.locals import *
import sys

pygame.init()

screen = pygame.display.set_mode((800, 650))

pygame.display.set_caption("Memoria French Chapter 4 Papime PE 400216 UNAM")

idioma = 2
colorElse = [255,255,255]

if idioma == 2:
 fondo = pygame.image.load('Images/French.jpg').convert()

Bfondo = pygame.transform.smoothscale(fondo, (800,650))

Titulo = os.path.join("fonts","Titulos.TTF")
subtitulos = os.path.join("fonts","subtitulos.TTF")

question_mark = pygame.image.load('Images/reverso.jpg').convert()
uz1 = pygame.transform.smoothscale(question_mark, (100,120))

blanco = pygame.image.load("Images/blanco.jpg").convert_alpha()
Sblanco = pygame.transform.smoothscale(blanco, (120, 50))

card_images = [pygame.image.load("Images/drawings/1.jpg"),\
               pygame.image.load("Images/drawings/2.jpg"),\
               pygame.image.load("Images/drawings/3.jpg"),\
               pygame.image.load("Images/drawings/4.jpg"),\
               pygame.image.load("Images/drawings/5.jpg"),\
               pygame.image.load("Images/drawings/6.jpg"),\
               pygame.image.load("Images/drawings/7.jpg"),\
               pygame.image.load("Images/drawings/8.jpg"),\
               pygame.image.load("Images/drawings/9.jpg"),\
               pygame.image.load("Images/drawings/10.jpg"),\
               pygame.image.load("Images/drawings/11.jpg"),\
               pygame.image.load("Images/drawings/12.jpg")]

concept_images = [pygame.image.load("Images/concepts/1.jpg"),\
                  pygame.image.load("Images/concepts/2.jpg"),\
                  pygame.image.load("Images/concepts/3.jpg"),\
                  pygame.image.load("Images/concepts/4.jpg"),\
                  pygame.image.load("Images/concepts/5.jpg"),\
                  pygame.image.load("Images/concepts/6.jpg"),\
                  pygame.image.load("Images/concepts/7.jpg"),\
                  pygame.image.load("Images/concepts/8.jpg"),\
                  pygame.image.load("Images/concepts/9.jpg"),\
                  pygame.image.load("Images/concepts/10.jpg"),\
                  pygame.image.load("Images/concepts/11.jpg"),\
                  pygame.image.load("Images/concepts/12.jpg")]

mismatch_images = [pygame.image.load("Images/mismatch/a.jpg").convert(),\
                   pygame.image.load('Images/mismatch/b.jpg').convert()]

class card(): 

    def __init__(self,c_type):

        self.c_type = c_type
        
        if rand_concept not in aux:
            aux.append(rand_card)
            p = 1
        else:
            p = 0
        
        if c_type < 12:
            
            if p == 1:
                self.image = card_images[c_type]
            else:
                self.image = concept_images[c_type]

        else:
            self.image = mismatch_images[c_type-12]

        self.matched = 0

    def get_c_type(self):
        return self.c_type 

    def get_image(self):
        return self.image 

    def set_matched(self):
        self.matched = 1

    def get_matched(self):
        return self.matched

p_points = 0
player_turn = 1

choice = [0,0]

screentype = 'main'

font2 = pygame.font.SysFont('Helvetica', 22)
font0 = pygame.font.Font(Titulo, 110)
font3 = pygame.font.Font(subtitulos, 42)
font4 = pygame.font.Font(subtitulos, 30)
color = colorElse

cards = []
aux = []
card_types = [0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12]

for i in range(25):

    rand_card = card_types[random.randint(0,len(card_types)-1)]
    rand_concept = rand_card
    rand_concept = rand_card
    cards.append(card(rand_card))
    card_types.remove(rand_card)

while 1:

    for event in pygame.event.get():
           
            if event.type == QUIT:
                pygame.quit()
                sys.exit()

    m = pygame.mouse.get_pressed()

    mx,my = pygame.mouse.get_pos()

#----- Screen Main ------
    if screentype == 'main':

        screen.blit(Bfondo, (0, 0))
        text0 = font0.render("Memoria",1,color)
        screen.blit(text0,(200,90))

        text1 = font3.render("Jugar",1,color)
        screen.blit(text1, (350, 300))
        
        if m[0] and 290 < mx < 510 and 290 < my < 395:
            screentype = 'game'
            pygame.time.wait(500)


#----- Screen Juego -----
    elif screentype == 'game':  

        screen.blit(Bfondo, (0, 0))

        msg_p1 = font2.render('Puntaje',1,(0,0,0))
        msg_p1p = font2.render(str(p_points),1,(0,0,0))
        
        screen.blit(Sblanco, (0, 270))
        screen.blit(msg_p1,(20,270))
        screen.blit(msg_p1p,(60,295))

        for x in range(5):      
            for y in range(5):
                if cards[x+y*5].get_matched() == 0:

                    if 150+x*100 < mx < 250+x*100 and y*120 < my < 120+y*120:

                        pygame.draw.rect(screen,(255,255,255),(150+x*100,y*120,100,120),3)

                        if m[0]:

                            if choice[0] == 0:
                                choice[0] = cards[x+y*5]

                            elif choice[1] == 0 and choice[0] != cards[x+y*5]:
                                choice[1] = cards[x+y*5]
                                
                    else:
                        pygame.draw.rect(screen,(0,0,0),(150+x*100,y*120,100,120),3)

                    screen.blit(uz1, (150+x*100, y*120))
                    
                    if choice[0] == cards[x+y*5]:
                        uz2 = pygame.transform.smoothscale(choice[0].get_image(), (100,120))
                        screen.blit(uz2, (150+x*100, y*120))
                        
                    if choice[1] == cards[x+y*5]:
                        uz3 = pygame.transform.smoothscale(choice[1].get_image(), (100,120))
                        screen.blit(uz3, (150+x*100, y*120))
                        
        if choice[0] != 0 and choice[1] != 0:

            pygame.display.flip()
            pygame.time.wait(2000)

            if choice[0].get_c_type() == choice[1].get_c_type():

                if player_turn == 1:
                    p_points += 1

                choice[0].set_matched()
                choice[1].set_matched()

            choice = [0,0]

        if p_points == 12:
            break

    pygame.display.flip()

    pygame.time.delay(20)  

quit()
